<?php
// $Id: locate.php,v 1.3 2006/12/17 05:01:39 ohwada Exp $

// 2006-12-17 K.OHWADA
// BUG 4417: singleton done not work correctly
// add get_local_instance() get_language_country_code() etc

// 2006-10-05 K.OHWADA
// this is new file
// porting form weblinks_language_base.php

//=========================================================
// Happy Linux Framework Module
// 2006-10-01 K.OHWADA
//=========================================================

//=========================================================
// class happy_linux_locate_base
//=========================================================
class happy_linux_locate_base
{
	var $_DEFAULT_COUNTRY_CODE = 'us';	// USA

	var $_vars = array();

//---------------------------------------------------------
// constructor
//---------------------------------------------------------
function happy_linux_locate_base()
{
	$this->_vars = array(
		'happy_linux_url' => 'http://linux2.ohwada.net/'
	);
}

//---------------------------------------------------------
// function
//---------------------------------------------------------
function build_google_search_url( $query, $google_url=null, $lang=null )
{
	if ( empty($google_url) )
	{
		$google_url = $this->get_var('google_url');
	}

	if ( empty($lang) )
	{
		$lang = _LANGCODE;
	}

	$query = happy_linux_convert_to_utf8($query);
	$query = urlencode($query);
	$url = $google_url .'search?hl='. $lang .'&q='.$query;
	return $url;
}

//---------------------------------------------------------
// get value
//---------------------------------------------------------
function get_default_contry_code()
{
	return $this->_DEFAULT_COUNTRY_CODE;
}

function &get_vars()
{
	return $this->_vars;
}

function get_var($name)
{
	$val = false;
	if ( isset($this->_vars[$name]) )
	{
		$val = $this->_vars[$name];
	}
	return $val;
}

function array_merge($arr)
{
// overwrite previus value
	$this->_vars = array_merge($this->_vars, $arr);
}

// --- class end ---
}


//=========================================================
// class happy_linux_locate_factory
//=========================================================
class happy_linux_locate_factory extends happy_linux_locate_base
{
	var $_DIRNAME = null;

	var $_config_handler = null;

//---------------------------------------------------------
// constructor
//---------------------------------------------------------
function happy_linux_locate_factory()
{
	$this->happy_linux_locate_base();
}

function &getInstance( $locate=null )
{
	static $instance;
	if (!isset($instance)) 
	{
		$factory  =& new happy_linux_locate_factory();
		$instance =& $factory->get_local_instance( $locate );
	}
	return $instance;
}

// BUG: singleton done not work correctly
function &get_local_instance( $locate=null )
{
	if ( empty($locate) )
	{
		$locate  =  $this->get_language_country_code();
	}
	$local =& $this->get_instance( $locate );
	return $local;
}

//---------------------------------------------------------
// get_instance
//---------------------------------------------------------
function &get_instance( $country_code=null, $prefix='happy_linux', $dirname='happy_linux' )
{
	if ( $country_code )
	{
		$instance =& $this->get_instance_by_country_code( $country_code, $prefix, $dirname );
		if ( $instance )
		{
			$this->_country_code = $country_code;
			return $instance;
		}
	}

	$instance =& $this->get_instance_by_country_code( $this->get_default_contry_code(), $prefix, $dirname  );
	if ( $instance )
	{
		return $instance;
	}

	$instance =& new happy_linux_locate_base();
	return $instance;
}

function &get_instance_by_country_code( $country_code, $prefix='happy_linux', $dirname='happy_linux' )
{
	$instance = false;
	$file     = XOOPS_ROOT_PATH.'/modules/'.$dirname.'/locate/'.$country_code.'/local.php';
	$class    = $prefix.'_locate_'.$country_code;

// BUG: singleton done not work correctly
// if include file alreary
	if ( class_exists($class) )
	{
		$instance =& new $class();
	}

// if NOT include file yet
	elseif ( file_exists($file) ) 
	{
		include_once $file;
		if ( class_exists($class) )
		{
			$instance =& new $class();
		}
	}

	return $instance;
}

//---------------------------------------------------------
// set & get parameter
//---------------------------------------------------------
function set_config_handler( &$handler )
{
	$this->_config_handler =& $handler;
}

function set_dirname( $dirname )
{
	$this->_DIRNAME = $dirname;
}

function get_dirname()
{
	return $this->_DIRNAME;
}

//---------------------------------------------------------
// set & get country code
//---------------------------------------------------------
function get_config_country_code()
{
	$code = null;
	if ( is_object($this->_config_handler) )
	{
		$conf = $this->_config_handler->get_conf();
		if ( isset($conf['country_code']) )
		{
			$code = $conf['country_code'];
		}
	}
	return $code;
}

//---------------------------------------------------------
// happy_linux_language_factory
//---------------------------------------------------------
function get_language_country_code()
{
	$factory =& happy_linux_language_factory::getInstance();
	$code    =  $factory->get_country_code();
	return $code;
}

// --- class end ---
}

?>